/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in 
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2007.  All Rights Reserved.
 *
 * Protege was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu.
 *
 */

/**
 * 
 */
package edu.stanford.smi.protege.storage.database.pool;

public class DatabaseParam {
    private String driver;
    private String url;
    private String username;
    private String password;
    
    public DatabaseParam(String driver, String url, String username, String password) {
        this.driver = driver;
        this.url = url;
        this.username = username;
        this.password = password;
    }
    
    public String getDriver() {
        return driver;
    }
    public String getUrl() {
        return url;
    }
    public String getUsername() {
        return username;
    }
    public String getPassword() {
        return password;
    }
    
    public boolean equals(Object o) {
        if (!(o instanceof DatabaseParam)) {
            return false;
        }
        DatabaseParam other = (DatabaseParam) o;
        return stringEquals(driver, other.driver)
            && stringEquals(url, other.url)
            && stringEquals(username, other.username)
            && stringEquals(password, other.password);
    }

    public int hashCode() {
        return driver.hashCode() + 42 * url.hashCode();
    }

    public boolean stringEquals(String s1, String s2) {
        if (s1 == s2) {
            return true;
        }
        else if (s1 == null || s2 == null) {
            return false;
        }
        else return s1.equals(s2);
    }
}